# barbacompta - invoicing for dummies
# Copyright (C) 2019-2020 Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import logging

import django
from uwsgidecorators import timer

django.setup()

logger = logging.getLogger('django.server')


@timer(300)
def update_cache(num):
    from . import decorators
    from .eo_banque.templatetags import eo_banque  # noqa pylint: disable=unused-import
    from .eo_facture.templatetags import eo_facture  # noqa pylint: disable=unused-import

    logger.info('updating cache')
    for func in decorators.cached_func:
        try:
            func.recompute()
        except Exception:
            logger.exception('failed to update cache for %s', func.__name__)
        else:
            logger.info('updated cache for %s.%s', func.__module__, func.__name__)
